#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<time.h>

#define OK 0
#define WARNING 1
#define CRITICAL 2
#define UNKNOWN 3
#define PERF_LINE_SIZE 2048
#define STATUS_LINE_SIZE 256 

// perfdata structure is a link list node contain current performance data of Sql sever
struct perf_data
{
	char object_name[100];
	char counter_name[100];
	char instance_name[100];
	long int cntr_value;
	long int cntr_type;
	struct perf_data *next;
};

// configur_data structure is a link list node contain configuration data for Sql sever
struct configur_data
{
        char object_name[100];
        char counter_name[100];
        char instance_name[100];
	long int cntr_value;
        long int cntr_type;
        char usr_def_name[100];
	char unit[30];
	long int warning_value;
        long int critical_value;
	char threshold_type[5];       
	int status;
        struct configur_data *next;
};

//declaring two lists
struct perf_data *current_data;
struct configur_data *config_data;

char servername[100];

int main(int argc, char *argv[])
{
int sqlserverstatus=OK, i=0;
char status_line[STATUS_LINE_SIZE];
char statstring[200];
char tempstring[50];
char conffile[100];
char perf_line[PERF_LINE_SIZE];
struct configur_data *config_head;
char command[200];
int command_status;
long int time_now;
char timenow[20];
char outputfile[100]="";
char errorfile[100]="";
char inputfile[100]="";
char basedir[100]="";

if(argc!=6)
{
       	printf("######################################################################################\n");
        printf("# Uses:  ./sqlsvr <plugin_director> <config_file_name> <host> <user_name> <password> #\n",argc);
        printf("# [1] ./sqlsvr           :-  name of the plugin executable (can use full path)       #\n");
        printf("# [2] <plugin_directory> :-  full path of the plugin directory                       #\n");
        printf("# [3] <config_file_name> :-  name of config file (just name not full path)           #\n");
        printf("# [4] <host>             :-  IP Address of the host where mysql server is            #\n");
        printf("# [5] <user_name>        :-  user name of mysql server                               #\n");
        printf("# [6] <password>         :-  password of mysql server                                #\n");
	printf("#                                                                                    #\n");
        printf("# eg. /plugins/MSSQL/mssql /plugins/MSSQL mssql.conf 148.12.15.124 sa sa             #\n");
        printf("######################################################################################\n");
        exit(2);
}

strcpy(basedir,argv[1]);
strcat(basedir,"/");

strcpy(outputfile,basedir);
strcpy(errorfile,basedir);
strcpy(conffile,basedir);
strcpy(inputfile,basedir);

strcat(inputfile,"inputquery.txt");
strcat(conffile,argv[2]);
strcat(outputfile,"outputdata");
strcat(errorfile,"error");

time_now=time(NULL);
sprintf(timenow,"%ld", time_now);

strcat(outputfile, timenow);
strcat(outputfile, ".txt");
strcat(errorfile, timenow);
strcat(errorfile, ".txt");

strcpy(command,basedir);
strcat(command,"bsqldb -S ");
strcat(command,argv[3]);
strcat(command," -U ");
strcat(command,argv[4]);
strcat(command," -P ");
strcat(command,argv[5]);
strcat(command," -i ");
strcat(command,inputfile);
strcat(command," -o ");
strcat(command,outputfile);
strcat(command," -e ");
strcat(command,errorfile);

//Executing command here
command_status=system(command);

if(command_status)
{
	printf("Error connecting MSSQL Server, Error:- ");
	errorcheck(errorfile);
	strcpy(command,"rm -f ");
	strcat(command,outputfile);
	system(command);

	strcpy(command,"rm -f ");
	strcat(command,errorfile);
	system(command);
	
	return 2;
}


tempstring[0]='\0';
statstring[0]='\0';
// Initialize two lists
current_data=NULL;
config_data=NULL;
config_head=NULL;
strcpy(status_line , "");

make_perfdata_list(outputfile);

make_configdata_list(conffile);

compare_two_lists();


config_head = config_data;
while(config_head)
{
	if((config_head->status > sqlserverstatus)&& (config_head->status != UNKNOWN))
		sqlserverstatus = config_head->status;
	config_head = config_head->next;
}

strcat(status_line,servername);
strcat(status_line,"- ");

switch(sqlserverstatus)
{
case 0:	
	strcat(status_line,"OK");
	break;
case 1:
        strcat(status_line,"WARNING");
	break;
case 2:
        strcat(status_line,"CRITICAL");
	break;
default:
	strcat(status_line,"UNKNOWN");
}

strcat(status_line,": ");

config_head = config_data;
while(config_head)
{
        if(!strcmp(config_head->threshold_type,"NA"))
        {
                tempstring[0]='\0';
                statstring[0]='\0';

                strcat(statstring,config_head->usr_def_name);
                strcat(statstring,"=");
		sprintf(tempstring,"%ld",config_head->cntr_value);
                strcat(statstring,tempstring);

                if(strcmp(config_head->unit,"NA"))
                {
                        strcat(statstring,config_head->unit);
                }

                strcat(statstring,"; ");

                if((strlen(status_line)+ strlen(statstring))<STATUS_LINE_SIZE)
                {
                        strcat(status_line,statstring);
                }

        }
        config_head=config_head->next;
}

config_head = config_data;
while(config_head)
{
	if(strcmp(config_head->threshold_type,"NA"))
	{
        	tempstring[0]='\0';
        	statstring[0]='\0';

        	if(config_head->status==CRITICAL)
        	{
		
        	        strcat(statstring,config_head->usr_def_name);
               		strcat(statstring,"=");
                	sprintf(tempstring,"%ld",config_head->cntr_value);
			strcat(statstring,tempstring);
			if(strcmp(config_head->unit,"NA"))
			{
				strcat(statstring,config_head->unit);
			}
			strcat(statstring,"; ");
		
        	        if((strlen(status_line)+ strlen(statstring))< STATUS_LINE_SIZE)
                	{     
                        	strcat(status_line,statstring);
                	}
        	}
	}
        config_head=config_head->next;
}

config_head = config_data;
while(config_head)
{
	if(strcmp(config_head->threshold_type,"NA"))
        {
		tempstring[0]='\0';
        	statstring[0]='\0';

       		if(config_head->status==WARNING)
        	{
               		strcat(statstring,config_head->usr_def_name);
               		strcat(statstring,"=");
                	sprintf(tempstring,"%ld",config_head->cntr_value);
                	strcat(statstring,tempstring);
                	if(strcmp(config_head->unit,"NA"))
                	{
                        	strcat(statstring,config_head->unit);
                	}
                	strcat(statstring,"; ");

	      		if((strlen(status_line)+ strlen(statstring))<STATUS_LINE_SIZE)
                	{
                       		strcat(status_line,statstring);
                	}
        	}
	}
        config_head=config_head->next;
}

config_head = config_data;
while(config_head)
{
        if(strcmp(config_head->threshold_type,"NA"))
	{
		tempstring[0]='\0';
        	statstring[0]='\0';

        	if((config_head->status!=CRITICAL)&&(config_head->status!=WARNING))
        	{
                	strcat(statstring,config_head->usr_def_name);
               		strcat(statstring,"=");
               		sprintf(tempstring,"%ld",config_head->cntr_value);
                	strcat(statstring,tempstring);
                	if(strcmp(config_head->unit,"NA"))
                	{
                        	strcat(statstring,config_head->unit);
                	}
                	strcat(statstring,"; ");
           
          	      	if((strlen(status_line)+ strlen(statstring))<STATUS_LINE_SIZE)
                	{
                        	strcat(status_line,statstring);
                	}
        	}
	}
        config_head=config_head->next;
}

strcpy(perf_line,"");
strcpy(tempstring,"");
strcpy(statstring,"");
config_head = config_data;
while(config_head)
{
        
	if(strcmp(config_head->threshold_type,"NA"))
	{
		tempstring[0]='\0';
        	statstring[0]='\0';

        	strcpy(statstring,config_head->usr_def_name);
        	strcat(statstring,"=");

        	sprintf(tempstring,"%ld",config_head->cntr_value);
        	strcat(statstring,tempstring);
		if(strcmp(config_head->unit,"NA"))
		{
			strcat(statstring,config_head->unit);
		}
		strcat(statstring,";");
	
		if(strcmp(config_head->threshold_type,"NTRQ"))
		{
			sprintf(tempstring,"%ld",config_head->warning_value);
        		strcat(statstring,tempstring);
			strcat(statstring,";");
	
			sprintf(tempstring,"%ld",config_head->critical_value);
        		strcat(statstring,tempstring);
        		strcat(statstring,";");
		}
	
		if((strlen(perf_line)+ strlen(statstring))<PERF_LINE_SIZE)
        	{
			strcat(perf_line,statstring);
        		strcat(perf_line," ");
		}
	}
            
	config_head=config_head->next;
}
		

printf("%s|%s\n",status_line,perf_line);

//remove output files
strcpy(command,"rm -f ");
strcat(command,outputfile);
system(command);

strcpy(command,"rm -f ");
strcat(command,errorfile);
system(command);

return sqlserverstatus;
}

int make_perfdata_list(char *outputfile)
{
        FILE *fp;
        char line[500];
        char *str;
        //declaring the nodes that will append to the end of list
	//struct perf_data perf_append;
	struct perf_data *temp,*previous;
	
	temp=NULL;
	previous=NULL;
	
	fp =fopen(outputfile,"r");
	if(fp==NULL)
        {
                printf("outputdata.txt:file not found");
                exit(1);
        }
	
	while(fgets(line,sizeof(line),fp)!=NULL)
	{
		
		temp=malloc(sizeof(struct perf_data));

		if(line[0]=='#')
		{
			str = strtok(line+1, ":");
			strcpy(servername,str);	
			
			str = strtok(NULL, "#");
			strcpy(temp->object_name,str);
			
			str = strtok(NULL, "#");
	                strcpy(temp->counter_name,str);
			
			str = strtok(NULL, "#");
                	strcpy(temp->instance_name,str);
			
			str = strtok(NULL, "#");
               		temp->cntr_value= atol(str);
			
			str = strtok(NULL, "#");
        	       	temp->cntr_type=atol(str);
						
		}
		
		if(current_data==NULL)
                {
			temp->next=NULL;
			current_data=temp;
			previous=temp;
                }
		else
		{
			previous->next=temp;
			previous=temp;
			temp->next=NULL;
		}

		
	}
	
return 0;
}

int make_configdata_list(char *conffile)
{
        FILE *fp;
        char line[500];
        char *str;
        //declaring the nodes that will append to the end of list
        //struct perf_data perf_append;
        struct configur_data *temp,*previous;

        temp=NULL;
        previous=NULL;

        fp =fopen(conffile,"r");
        if(fp==NULL)
        {
                printf("%s:file not found\n",conffile);
                exit(1);
        }

        while(fgets(line,sizeof(line),fp)!=NULL)
        {
	    if(line[0]=='#')
	    {

                temp=malloc(sizeof(struct configur_data));
                
                str = strtok(line, "#");
                strcpy(temp->object_name,str);
                      
                str = strtok(NULL, "#");
                strcpy(temp->counter_name,str);
                        
                str = strtok(NULL, "#");
                strcpy(temp->instance_name,str);
                        
                str = strtok(NULL, "#");
                temp->warning_value= atol(str);
                        
                str = strtok(NULL, "#");
                temp->critical_value=atol(str);
                        
		str = strtok(NULL, "#");
                strcpy(temp->threshold_type,str);

		str = strtok(NULL, "#");
                strcpy(temp->usr_def_name,str);
			
		str = strtok(NULL, "#");
                strcpy(temp->unit,str);

		temp->status=UNKNOWN;
		temp->cntr_value=-1;
		temp->cntr_type=-1;
                

                if(config_data==NULL)
                {
                        temp->next=NULL;
                        config_data=temp;
                        previous=temp;
                }
                else
                {
                        previous->next=temp;
                        previous=temp;
                        temp->next=NULL;
                }

	}


        }
return 0;
}

int compare_two_lists()
{
	struct perf_data *perf_temp;
	struct configur_data *config_temp;
	perf_temp=current_data;
	config_temp=config_data;
	if(config_temp==NULL)
        return(1);

	while( config_temp!=NULL)
	{
		if(perf_temp==NULL)
		{
			printf("The counter %s:%s:%s not found",config_temp->object_name,config_temp->counter_name,config_temp->instance_name);
			return(1);
		}

		if(strcmp(perf_temp->object_name,config_temp->object_name))
		{
			perf_temp=perf_temp->next;
			continue;
		}
		else if(strcmp(perf_temp->counter_name,config_temp->counter_name))
		{
			perf_temp=perf_temp->next;
			continue;
		}
		else if(strcmp(perf_temp->instance_name,config_temp->instance_name))
		{
			perf_temp=perf_temp->next;
			continue;
		}
		
		if(!strcmp(config_temp->threshold_type,"INCR"))
		{
			if(perf_temp->cntr_value>=config_temp->critical_value)
			{
				config_temp->status=CRITICAL;
			}
			else if(perf_temp->cntr_value>=config_temp->warning_value)
			{
				config_temp->status=WARNING;
			}
			else
			{
				config_temp->status=OK;
                       	}
		
			config_temp->cntr_value=perf_temp->cntr_value;
                        config_temp->cntr_type=perf_temp->cntr_type;

		}
		else if(!strcmp(config_temp->threshold_type,"DECR"))
		{
			 if(perf_temp->cntr_value<=config_temp->critical_value)
                        {
                                config_temp->status=CRITICAL;
                        }
                        else if(perf_temp->cntr_value<=config_temp->warning_value)
                        {
                                config_temp->status=WARNING;
                        }
                        else
                        {
                                config_temp->status=OK;
                        }

			config_temp->cntr_value=perf_temp->cntr_value;
		        config_temp->cntr_type=perf_temp->cntr_type;
		}

		 else if(!strcmp(config_temp->threshold_type,"NTRQ"))
                {
                        config_temp->status=OK;
                        config_temp->cntr_value=perf_temp->cntr_value;
			config_temp->cntr_type=perf_temp->cntr_type;
                }
                else if(!strcmp(config_temp->threshold_type,"NA"))
                {
                        config_temp->status=OK;
                        config_temp->cntr_value=0;
			config_temp->cntr_type=perf_temp->cntr_type;
                }

		else
		{
			printf("The Threshold type of %s:%s:%s is not correct",config_temp->object_name,config_temp->counter_name,config_temp->instance_name);
			return(1);
			config_temp->cntr_value=perf_temp->cntr_value;
                        config_temp->cntr_type=perf_temp->cntr_type;
			config_temp->status=UNKNOWN;
		}

		config_temp=config_temp->next;
		perf_temp=current_data;
	}
return 0;
}

int errorcheck(char *errorfile)
{
 	FILE *fp;
	char line[200];
	
        
        fp =fopen(errorfile,"r");
        if(fp==NULL)
        {
                printf("errorfile not found");
                exit(1);
        }

        while(fgets(line,sizeof(line),fp)!=NULL)
        {

                line[strlen(line)-1]='\0';
		printf("%s; ",line);                
        }

        return 0;
}

